////////////////////////////////////////////////////////////////////////////////
//  BeholdTv   
//    - "BPP_DrawText.dll"
// Pavel Negrobov, 23.04.2010
////////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "resource.h"

#include <stdio.h>
#include <windows.h>
#include <commctrl.h>

#include "Common.h"
#include "BPP_DrawText.h"

#include "convert_yuy2.h"

#pragma pack (1)

#define BH_PLUGIN_EXP	__declspec(dllexport)

//     
#define szPluginName	"  "

//  ,  		
#define szPluginDesc	"  , v1.00"

#define ICERR_OK                0L

//    
char g_szIniFile[MAX_PATH];

HINSTANCE g_hInst = NULL;
HWND g_hDlg = NULL;

//   - RGB24/YUV2
ePixFmt pxFormat;

// 
HDC hdc=NULL, hMemDc=NULL;

//   Bitmap
LPBYTE pBmpData=NULL;

// Handle  Bitmap
HBITMAP hNewBmp;

//   memcpy
MCPY_FUNC *pMcpy;

//    
void WriteText (LPBYTE pFrame, int width, int height, LPCTSTR pString);

//  YUY2<->RGB32 
LPBYTE ConvertYUY2_RGB24 (LPBYTE pSrcFrame, int width, int height, BOOL isToRgb);

// ********************* DllMain ************************************************
BOOL APIENTRY DllMain( HINSTANCE hModule, DWORD ul_reason_for_call, LPVOID lpReserved )
{
	switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
			g_hInst = hModule;
			break;
		case DLL_PROCESS_DETACH:
			break;
	} // switch

	return TRUE;
}
//       ,    
void GetIniFileName()
{
	char	szPathFull[MAX_PATH];
	char	szPathIni[MAX_PATH];
	char	szNameDll[MAX_PATH];
	char	szNameIni[MAX_PATH];
	char	*pszFile;

	if (GetModuleFileName(g_hInst, (LPTSTR)szPathFull, sizeof(szPathFull)))
	{
		if (GetFullPathName((LPCTSTR)szPathFull, sizeof(szPathIni), (LPTSTR)szPathIni, (LPTSTR *)&pszFile))
		{
			strcpy(szNameDll, pszFile);

			int	nLen = (int)strlen(szNameDll) - 4;

			strncpy(szNameIni, szNameDll, nLen);
			szNameIni[nLen] = 0;

			strcat(szNameIni, ".ini");
			strcpy(pszFile, szNameIni);

			strcpy(g_szIniFile, szPathIni);
			pszFile = NULL; 
		}
	} // if
} // GetIniFileName

//   
void LoadPluginSettings()
{
} // LoadPluginSettings

//   
void SavePluginSettings()
{
} // SavePluginSettings

// Callback     
LRESULT CALLBACK DialogProc(HWND hDlgW, UINT message, WPARAM wParam, LPARAM lParam)
{	
	static BOOL s_IsCaptureMode;

	switch (message)
	{
		case WM_INITDIALOG:			//  
			// ,      
			s_IsCaptureMode = (BOOL) lParam;  

			//      
			SetWindowText(hDlgW, (LPCTSTR)szPluginName);

			return TRUE;
			break;

		case WM_DESTROY:			//  
			g_hDlg = NULL;
			SavePluginSettings();
			return TRUE;
			break;

		case WM_COMMAND:			//     
			switch LOWORD(wParam)
			{
				case ID_OK:		//  ""
					DestroyWindow(hDlgW);
					return TRUE;
					break;

				default:
					break;
			} // switch
			break;

		default:
			break;
	} // switch
	return FALSE;
} // DialogProc

// ******************   (  API) *********************

////////////////////////////////////////////////////////////////////////////////
// *   *
////////////////////////////////////////////////////////////////////////////////
void __cdecl Init(INIT_STR *pPrInit)
{
	//     

	//  
	LoadPluginSettings();  
} // Init

////////////////////////////////////////////////////////////////////////////////
// *  StartStreaming *
////////////////////////////////////////////////////////////////////////////////
BOOL __cdecl StartStreaming(PARAM_STR *pPrPar)
{
	//   
	pxFormat = pPrPar ->PixFmt;

	//  
	int width = pPrPar->FrameWidth;
	int height = pPrPar->FrameHeight;

//	FILE *fp=fopen ("c:\\log.txt", "at");
//	fprintf(fp, "StartStreaming: %dx%d\n", width, height);
//	fclose(fp);

	//   GDI
	// 
	if ( hdc == NULL )
	{
		hdc = ::GetDC(NULL);
		hMemDc = ::CreateCompatibleDC(hdc);

		// 
		BITMAPINFO bmpHeader;
		::ZeroMemory (&bmpHeader, sizeof(bmpHeader));
		bmpHeader.bmiHeader.biSize = sizeof (BITMAPINFOHEADER);
		bmpHeader.bmiHeader.biWidth = width;
		bmpHeader.bmiHeader.biHeight = -height;
		bmpHeader.bmiHeader.biPlanes = 1;
		bmpHeader.bmiHeader.biBitCount=24;
		bmpHeader.bmiHeader.biCompression = BI_RGB;	// 
		bmpHeader.bmiHeader.biSizeImage=0;	//  BI_RGB

		hNewBmp = ::CreateDIBSection (hMemDc, &bmpHeader, 
			DIB_RGB_COLORS, (LPVOID *)&pBmpData, NULL, 0);
	} // if

	return TRUE;
} // StartStreaming


////////////////////////////////////////////////////////////////////////////////
// *   *
////////////////////////////////////////////////////////////////////////////////
BOOL __cdecl Processing (PROC_STR *pPr)
{
	//    ,   
	if (pPr->IsHSync!=0)
		return TRUE;

	//      
	if ((LPBYTE) pPr->SrcBuff[0] == NULL)
		return FALSE;

	//  
	if ( hdc == NULL )
		return FALSE;

	//  
	int width = pPr->FrameWidth;
	int height = pPr->FrameHeight;

	//    memcpy
	pMcpy = pPr->pMcpy;

	WriteText ( (LPBYTE) pPr->SrcBuff[0], width, height, 
		" ,   !" ); 

	return TRUE;
} // Processing

////////////////////////////////////////////////////////////////////////////////
// *  StopStreaming *
////////////////////////////////////////////////////////////////////////////////
void __cdecl StopStreaming(void)
{
	//     
	// (      ..)

//	FILE *fp=fopen ("c:\\log.txt", "at");
//	fprintf(fp, "StopStreaming\n\n");
//	fclose(fp);

	if (hdc!=NULL)
	{
		DeleteObject(hNewBmp);
		DeleteObject(hMemDc);
		DeleteObject(hdc);
		GdiFlush ();

		hdc = NULL;
	} // if
} // StopStreaming


////////////////////////////////////////////////////////////////////////////////
// *     *
////////////////////////////////////////////////////////////////////////////////
void __cdecl ShowDialog(DLG_STR *pDlgPar)
{
	if(g_hDlg == NULL)
	{
		if (g_szIniFile[0] == 0)
			LoadPluginSettings();

		// pDlgPar->LangCode   ,      

		g_hDlg = CreateDialogParam(g_hInst, (LPCTSTR) IDD_DIALOGCONFIG, pDlgPar->hwndParent,
			(DLGPROC) DialogProc, (LPARAM) pDlgPar->IsCapture);
		if (g_hDlg)
		{
			//      
			RECT pRect, lRect;			

			GetWindowRect(pDlgPar->hwndParent, &pRect);
			GetWindowRect(g_hDlg, &lRect);

			int lft, top;

			lft = pRect.left + (pRect.right / 2 - lRect.right / 2);		
			top = pRect.top + (pRect.bottom / 2 - lRect.bottom / 2);

			SetWindowPos(g_hDlg, HWND_TOP, lft, top, 0, 0, SWP_NOACTIVATE | SWP_NOSIZE);
			ShowWindow(g_hDlg, SW_SHOW);
		}
    } // if

} // ShowDialog

////////////////////////////////////////////////////////////////////////////////
// *   *
////////////////////////////////////////////////////////////////////////////////
void __cdecl Uninit(void)
{
	//     

	//   
	SavePluginSettings();

	if(g_hDlg != NULL)
	{
		DestroyWindow(g_hDlg);  //  
		g_hDlg = NULL;
	} // if
} // uninit

////////////////////////////////////////////////////////////////////////////////
// *     *
////////////////////////////////////////////////////////////////////////////////
PROC_PLUGIN Inverse_PL =
{
	szPluginName,				//   (  )
	szPluginDesc,				//  
	Init,						//     (  NULL)
	StartStreaming,				//    StartStreaming (  NULL)
	Processing,					//     ()
	StopStreaming,				//    StopStreaming (  NULL)
	ShowDialog,					//       (  NULL)
	Uninit						//     (  NULL)
};

// ********************* Exports ***********************************************
extern "C"
{
	BH_PLUGIN_EXP ULONG BeholdTV_Plugin_Version()
	{
		return DSPLUGINVER;		//    
	}

	BH_PLUGIN_EXP PROC_PLUGIN* BeholdTV_Plugin_PR()
	{
		return &Inverse_PL;		//     
	}
} // extern

// *********************   ************************************
//    
void WriteText (LPBYTE pFrame, int width, int height, LPCTSTR pString)
{
	LPBYTE pRgb24Data;
	int rgb24size = width*height*3;
	int yuy2size = width*height*2;

	if ( pxFormat == fYUY2 )
	{
		// YUY2->RGB24
		pRgb24Data = ConvertYUY2_RGB24 (pFrame, width, height, true);
	} // if
	else
	{ //    RGB24
		pRgb24Data = new BYTE[rgb24size];
		(*pMcpy) (pRgb24Data, pFrame, rgb24size);
	} // else

	////////////////////////////////////////////////////////////////////////////
	// 
	
	//     bitmap
	(*pMcpy) (pBmpData, pRgb24Data, rgb24size);
	delete pRgb24Data;

	SelectObject(hMemDc, hNewBmp);

	//  
	SetTextColor(hMemDc, RGB ( 0, 255, 0 ));

	//  
	SetBkMode(hMemDc, TRANSPARENT);

	// 
	// Arial Cyr, 24
	long lfHeight = -MulDiv(24, GetDeviceCaps(hdc, LOGPIXELSY), 72);
	HFONT hFont = CreateFont(lfHeight, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, "Arial Cyr");

    SelectObject(hMemDc, hFont);

	RECT r;
	SetRect(&r, 1,1,width,height);
    DrawText(hMemDc, pString, -1, &r, DT_CENTER|DT_VCENTER|DT_SINGLELINE ); 
    DeleteObject(hFont);

	//  
	////////////////////////////////////////////////////////////////////////////

	//   YUY2
	if ( pxFormat == fYUY2 )
	{
		// YUY2->RGB24
		LPBYTE pYuy2 = ConvertYUY2_RGB24 (pBmpData, width, height, false);
//		LPBYTE pYuy2 = ConvertYUY2_RGB24 (pRgb24Data, width, height, false);
		(*pMcpy) (pFrame, pYuy2, yuy2size);
//		delete pRgb24Data;
		delete pYuy2;
	} // if
	else
	{ //    RGB24
		(*pMcpy) ( pFrame, pBmpData, rgb24size);
//		(*pMcpy) ( pFrame, pRgb24Data, rgb24size);
	} // else
} // WriteText

//  YUY2<->RGB32 
LPBYTE ConvertYUY2_RGB24 (LPBYTE pSrcFrame, int width, int height, BOOL isToRgb)
{
	//  
	int Mode = isToRgb?MODE_mmx_ConvertYUY2toRGB24:MODE_mmx_ConvertRGB24toYUY2;
	int srcStride, dstStride, srcSize, dstSize;
	LPBYTE pDst = NULL;
	
	int iMatrix = 0; // 0..3 //0=rec601, 1=rec709, 3=PC_601, 7=PC_709

	switch(Mode)
	{
		case MODE_mmx_ConvertRGB24toYUY2:	// RGB24->YUY2
			{
				srcStride = width * 3;
				dstStride = width * 2;
				srcSize = srcStride * height;
				dstSize = dstStride * height;
				
				pDst = new BYTE[dstSize];

				// 
				Tmmx_ConvertRGBtoYUY2<true, false>::mmx_ConvertRGBtoYUY2(pSrcFrame, pDst,
					srcStride, dstStride, width, height, iMatrix);
			}
		break;

		case MODE_mmx_ConvertYUY2toRGB24:	// YUY2->RGB24
			{
				srcStride = width * 2;
				dstStride = width * 3;
				srcSize = srcStride * height;
				dstSize = dstStride * height;
				
				pDst = new BYTE[dstSize];

				// 
				Tmmx_ConvertYUY2toRGB<false, false>::mmx_ConvertYUY2toRGB(pSrcFrame, pDst,
					pSrcFrame + (height * srcStride), srcStride, dstStride, width * 2, iMatrix);
			}
		break;	
	} // switch

	return pDst;
} // ConvertYUY2_RGB24
