#ifndef __COMMON_H__
#define __COMMON_H__ 


//     DirectShow  (  )
#define DSPLUGINVER			0x0003


//      
#define MAX_NAME_LENGTH	64


//   (  )
#define CPU_SIMPLE		1	//  
#define CPU_MMX			2	//   MMX
#define CPU_K7			3	// AMD Athlon XP/Duron Morgan or higher (Extended MMX + SSE + prefetch)
#define CPU_SSE			4	// Intel SSE (Pentium III)
#define CPU_SSE2		5	// Intel SSE2 (Pentium 4)


//     memcpy (MMX, Athlon, SSE)
typedef void (MCPY_FUNC)(void *pDst, const void *pSrc, size_t nSize);


//  
enum ePixFmt
{
	fYUY2 = 0,
	fRGB24
};


//  ,    ,   
//    ,     CPU 
typedef struct
{
	int FrameWidth;			//  
	int FrameHeight;		//  
	int BitPerPixel;		//    (2  16bpp; 3  24bpp ))
	ePixFmt PixFmt;			//   (YUY2  RGB24)
	ULONG TypeCPU;			//  
	BOOL IsCapture;			// , ,         

} PARAM_STR;


//  ,    ,     
typedef struct
{
	HWND hwndParent;		//   
	BOOL IsCapture;			//       
	ULONG LangCode;			//   (   )

} DLG_STR;


/////////////////////////////////////////////////////////////////////////////////////////////////////////
// API   
//
//                              
//     Dynamic-Link Library (dll), 
//    BPD_*.dll   :
//
// "BeholdTV_Plugin_Version"
// "BeholdTV_Plugin_DI".
//
//     -    ,  
//  "",  -     
//    . 
//
//         
//   (DstBuffer).    DstBuffer    
//   .
//
//     DirectShow      
//     DINT_PLUGIN_FUNC.     
// .
/////////////////////////////////////////////////////////////////////////////////////////////////////////

//  ,       DINT_PLUGIN_FUNC 
//  
typedef struct
{
	BYTE **SrcOdd[4];   //      (   )
	BYTE **SrcEven[4];  //      (   )
						//    [0] - . [1], [2], [3] -   

	BYTE *DstBuffer;	//     		

	MCPY_FUNC *pMcpy;   //     memcpy (MMX, AthlonXP, SSE) -  

	BOOL IsOdd;			//   

	int FrameWidth;		//   ( )
	int FieldHeight;    //   (  / 2) -  
	int SrcLength;      //    (  *    / 8) -  
	int SrcPitch;       //       (2 *   *    / 8) -  
	int DstPitch;       //        (   *    / 8) -  

// -=  ,    =-

	BOOL IsDoubleFps;	// ,        (  
						//         )

} DINT_STR;


//       
typedef void (__cdecl DINT_PLUGIN_INIT)(void);
typedef BOOL (__cdecl DINT_PLUGIN_START)(PARAM_STR *pDiPar);
typedef BOOL (__cdecl DINT_PLUGIN_FUNC)(DINT_STR *pDi);			//    
typedef void (__cdecl DINT_PLUGIN_STOP)(void);
typedef void (__cdecl DINT_PLUGIN_DIALOG)(DLG_STR *pDlgPar); 
typedef void (__cdecl DINT_PLUGIN_UNINIT)(void);


//  ,      
typedef struct
{
	char				*szName;		//   ()
	char				*szDesc;		//  
	DINT_PLUGIN_INIT	*pPluginInit;	//       (   )
	DINT_PLUGIN_START	*pPluginStart;	//    StartStreaming  (   )
	DINT_PLUGIN_FUNC	*pPluginDeint;	//     (     Deliver )
	DINT_PLUGIN_STOP	*pPluginStop;	//    StopStreaming   (   )
	DINT_PLUGIN_DIALOG	*pPluginDialog;	//       
	DINT_PLUGIN_UNINIT	*pPluginUninit;	//     (   )

} DINT_PLUGIN;


//     c  "BeholdTV_Plugin_Version"
typedef ULONG (__cdecl BEHOLDTV_PLUGIN_VERSION)(void);         

//     c  "BeholdTV_Plugin_DI"
typedef DINT_PLUGIN* (__cdecl BEHOLDTV_PLUGIN_DI)(void);         



/////////////////////////////////////////////////////////////////////////////////////////////////////////
// API   
//
//                              
//     Dynamic-Link Library (dll), 
//    BPP_*.dll   :
//
// "BeholdTV_Plugin_Version"
// "BeholdTV_Plugin_PR"
//
//     -      
//  .
//
//         (SrcBuff).
//
//     DirectShow      
//     PROC_PLUGIN_FUNC.     
// .
/////////////////////////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////////////////////////
//  
/////////////////////////////////////////////////////////////////////////////////////////////////////////

// 
enum eVStd
{
	VSTD_AUTODETECT = 0,   // Automatic detection
	VSTD_SECAM,            // 50Hz, SECAM
	VSTD_PAL,              // 50Hz, PAL BGDHI
	VSTD_PAL_60,           // 60Hz, PAL 60
	VSTD_NTSC_M,           // 60Hz, NTSC M
	VSTD_NTSC_Japan        // 60Hz, NTSC-Japan
};

// 
enum eAStd 
{
	ASTD_0 = 0,		
	ASTD_1,
	ASTD_2,
	ASTD_3,
	ASTD_4,
	ASTD_5,
	ASTD_6,
	ASTD_7,
	ASTD_8,
	ASTD_9,
	ASTD_10,
	ASTD_11,
	ASTD_12,
	ASTD_13,
	ASTD_14,
	ASTD_15
};

//     
typedef struct
{
	__int64		ChnlIdx;					//     (   = -1,  CompositeIn = 1,  S-VideoIn = 2)
	int			ChnlOrder;					//     (   = -1,  CompositeIn = -2,  S-VideoIn = -3)
	char		ChnlName[MAX_NAME_LENGTH];	//    ( CompositeIn = "Composite",  S-VideoIn = "S-Video")
	long		Frequency;					//   ( 49.75 = 49750000.  CompositeIn/S-VideoIn = 0)

	eVStd		VideoStd;					// 
	eAStd		AudioStd;					// 

	int			Brightness;					// 
	int			Contrast;					// 
	int			Saturation;					// 
	int			Hue;						// 
	int			Sharpness;					// 
	int			Gain;						//  

	int			AudioVolume;				// 
	int			AudioBalance;				// 

	int			Zoom;						//    %
	int			LeftOffSet;					//      %
	int			TopOffSet;					//      %

} TChannelInfo;


//        
typedef TChannelInfo* (BY_ORD_FUNC)(int ChOrder);

//        
typedef TChannelInfo* (BY_IDX_FUNC)(__int64 ChIdx);

/////////////////////////////////////////////////////////////////////////////////////////////////////////

//  ,       PROC_PLUGIN_INIT 
typedef struct
{
	BY_ORD_FUNC *pChByOrd;	//   ,           (   ,  NULL)
	BY_IDX_FUNC *pChByIdx;	//   ,            (   ,  NULL)

} INIT_STR;



//  ,       PROC_PLUGIN_FUNC 
typedef struct
{

	BYTE *SrcBuff[4];		//     (   ). 
							//    [0] - . [1], [2], [3] -   

	MCPY_FUNC *pMcpy;		//     memcpy (MMX, AthlonXP, SSE) -  
    
	int FrameWidth;			//   ( )
	int FrameHeight;		//   ( )

	int SrcLength;			//    (  *    / 8) -  
	int SrcPitch;			//       (  *    / 8) -  

// -=  ,    =-

	BOOL IsHSync;			// , ,       (. )
	BOOL IsChnlChanged;		// ,      (  )

	TChannelInfo *ChInfo;	//      (   CompositeIn/S-VideoIn)

} PROC_STR;


//      
typedef void (__cdecl PROC_PLUGIN_INIT)(INIT_STR *pPrInit);
typedef BOOL (__cdecl PROC_PLUGIN_START)(PARAM_STR *pPrPar);
typedef BOOL (__cdecl PROC_PLUGIN_FUNC)(PROC_STR *pPr);				//    
typedef void (__cdecl PROC_PLUGIN_STOP)(void);
typedef void (__cdecl PROC_PLUGIN_DIALOG)(DLG_STR *pDlgPar);
typedef void (__cdecl PROC_PLUGIN_UNINIT)(void);


//  ,      
typedef struct
{
	char				*szName;		//   ()
	char				*szDesc;		//  
	PROC_PLUGIN_INIT	*pPluginInit;	//     (   )
	PROC_PLUGIN_START	*pPluginStart;	//    StartStreaming (   )
	PROC_PLUGIN_FUNC	*pPluginProc;	//     (     Deliver )
	PROC_PLUGIN_STOP	*pPluginStop;	//    StopStreaming (   )
	PROC_PLUGIN_DIALOG	*pPluginDialog;	//       
	PROC_PLUGIN_UNINIT	*pPluginUninit;	//     (   )

} PROC_PLUGIN;



//     c  "BeholdTV_Plugin_Version"
typedef ULONG (__cdecl BEHOLDTV_PLUGIN_VERSION)(void);         

//     c  "BeholdTV_Plugin_PR"
typedef PROC_PLUGIN* (__cdecl BEHOLDTV_PLUGIN_PR)(void);         



#endif